package ru.dbotthepony.mc.otm.menu.storage

import net.minecraft.world.entity.player.Inventory
import ru.dbotthepony.mc.otm.block.entity.storage.StorageBusBlockEntity
import ru.dbotthepony.mc.otm.container.ItemFilterNetworkSlot
import ru.dbotthepony.mc.otm.menu.MatteryPoweredMenu
import ru.dbotthepony.mc.otm.menu.input.BooleanInputWithFeedback
import ru.dbotthepony.mc.otm.menu.input.IntInputWithFeedback
import ru.dbotthepony.mc.otm.registry.MMenus

class StorageBusMenu @JvmOverloads constructor(
	containerId: Int,
	inventory: Inventory,
	tile: StorageBusBlockEntity? = null
) : MatteryPoweredMenu(MMenus.STORAGE_BUS, containerId, inventory, tile)  {
	val busFilterSlots: List<ItemFilterNetworkSlot>
	val busFilterState: BooleanInputWithFeedback
	val insertPriority: IntInputWithFeedback
	val extractPriority: IntInputWithFeedback

	init {
		if (tile != null) {
			busFilterSlots = addFilterSlots(tile.filter)
			busFilterState = BooleanInputWithFeedback(this, tile.filter::isWhitelist)
			insertPriority = IntInputWithFeedback(this, tile::insertPriority)
			extractPriority = IntInputWithFeedback(this, tile::extractPriority)
		} else {
			busFilterSlots = addFilterSlots(StorageBusBlockEntity.MAX_FILTERS)
			busFilterState = BooleanInputWithFeedback(this)
			insertPriority = IntInputWithFeedback(this)
			extractPriority = IntInputWithFeedback(this)
		}

		addStorageSlot(batterySlot)
		addInventorySlots()
	}
}
